#include "const.h"
#include <stdio.h>
#include <fcntl.h>

#define EXISTE_PROCESO (nro_proc != MAX_PROC)
#define EXISTE_ALARMA  (almid != MAX_ALM)
#define DISPLAY 1

/* constantes alarma */
#define ALTA  1
#define BAJA  2

extern pid_t pids[];

input()
{
   /* Estas tarea permite ingrear varias opciones, que indican lo que debe
   hacer el PLC. Se escriben los datos en el tableau y en la cola al PLC,
   para que lo tome el driver (en el caso de que sea necesario). */     

   /* La onda es la siguiente: como el display y el input son tareas inde-
   pendientes, las sincronizo con un flag para evitar la superposicion de
   carteles y problemas. La otra posibilidad seria tratar de usar la llama-
   da getch, getc, para leer sin buffer. */
    
   char nom_proc[TAM_NOM], nom_disp[TAM_NOM];	
#ifdef RT
    char nada[TAM_NOM];
   extern int pp_tasa[];
   char tpo_per_s[3]; /* Solo se usa para sacar del pp_tasa[] el viejo
			valor de la tasa de refresco de display */
#endif
   int tabla, indice, codigo, port;
   real valor;
   char comando[6];
   extern pp_to_display[], pp_to_input[];
   int c;
   int nro_proc;
   int i, d1, d2; /* dummy */
   real read_real();
   char tipo[4];
   time_t *hora, tpo_esp;
   int tpo_per;
   pid_t pid;
   FILE *historic, *arch_nom;
   int stdprn;
   short estado;
   char buff_imp[80];
   int cuando, detec, frec;
   char almid[TAM_NOM], procedim[TAM_NOM];
   char prio;
   real al_min, al_max;
   int cant_ref;
   int porcent;

   signal(SIGUSR2, SH);
   close(pp_to_input[1]);
   clscr();  

#ifdef RT
   tpo_per = T_DISPLAY;
   write(pp_tasa[1],itoa(tpo_per),3);
   write(pp_to_display[1], Off, TAM_NOM);
#endif

   while(SIEMPRE)
   {
   printf("Ingrese el comando a ejecutar (help): \n");
   scanf("%s", comando);
/*   clscr();   */
	
   mayusc(comando);
   codigo = traducir(comando);

	switch(codigo)
	{
	case DISP: /* Muestra valores de un proceso */
		
		nro_proc = ingreso_nombre(nom_proc);

		if (EXISTE_PROCESO) {
#ifdef RT
			read(pp_to_display[0], nada, TAM_NOM);			
#endif
			write(pp_to_display[1], nom_proc, TAM_NOM);
		}
		else 
			printf("No existe tal proceso \n");
		break;


	case CAM : /* Cambia el valor de un proceso */

		nro_proc = ingreso_nombre(nom_proc);
		if (!EXISTE_PROCESO)
			{
			printf("No existe tal proceso \n");
			break;
			}

		printf("Dispositivo (nombre logico del dispositivo del proceso): ");
		scanf("%s", nom_disp);

	     	nro_proc = exist_disp(nom_disp);
		if (!EXISTE_PROCESO)
			{
			printf("No existe tal dispositivo \n");
			break;
			}
			
		get_proc(nro_proc, &tabla, &indice, nom_proc, nom_disp, porcent);
		
		printf("Ingrese el nuevo valor para el proceso \n");
		valor = read_real(tabla);

		writemem(tabla, indice, valor, TODO_OK);
		driv_qwrite(tabla, indice, valor, TODO_OK);
		break;


	case CALM: /* Cambia los valores de alarma */
		
		printf("Identificador de alarma: "); scanf("%s", almid);
		i = buscar_alm(almid, &tabla, &indice, nom_proc, &frec, &prio,
		  procedim, &cuando, &al_min, &al_max, &tpo_esp, &cant_ref);

		if (!EXISTE_ALARMA)
			{
			printf("No existe tal identificador \n");
			break;
			}
			
		ingresar_alarmas(&tabla, &indice, nom_proc, &frec, &prio,
		  procedim, &cuando, &al_min, &al_max);

		put_alm_q(i, almid, tabla, indice, nom_proc, frec, prio,
		  procedim, cuando, al_min, al_max, (time_t) 0, cant_ref);

		break;


	case DEFPAR:   /* Ingresar el nuevo parametro de un proceso */	

		printf("Nombre del proceso: ");
		scanf("%s", nom_proc);
		printf("Nombre del dispositivo: ");
		scanf("%s", nom_disp);
		printf("Ingrese el tipo de dato a ser controlado (ent-dig-real): ");
		scanf("%s", tipo);
		tabla = str_to_tabla(tipo);
		printf("Tasa de cambio para actualizacion historicos (0-99%): ");
		scanf("%d", &porcent);
		
		indice = busq_tableau_libre(tabla);

#ifdef COSO1
		printf("Tabla: %d, Indice: %d \n", tabla, indice);
#endif

 		if (indice == NO_HAY_ESPACIO) 
			{
			  printf("No hay mas espacio en esa tabla \n");
			  break;
		         }

		add_proc(nom_proc, nom_disp, indice, tabla, porcent);
		
		printf("Port de comunicaciones al que conecta el nuevo proceso:");
		scanf("%d", &port);
		init_PLC(port, tabla, indice);

		writemem(tabla, indice, valor, TODO_OK);
		driv_qwrite(tabla, indice, valor, TODO_OK);

		break;


	case SHELL:   /* Correr un shell */
		system("sh");
		break;


	case HELP:   /* hacer un help */
		clscr(); 
		printf("ACK   : Reconoce una alarma \n");
		printf("APAGAR: Apaga el display \n");
		printf("CALM  : Cambia los valores de alarma \n");
		printf("CAM   : Cambia un valor de un dispositivo \n");
		printf("CAMREF: Cambia la tasa de refresh del display\n");
		printf("CLS   : Borra la pantalla \n");
		printf("DEFALM: Agrega una alarma \n");
		printf("DEFPAR: Ingresa nuevos parametros para un proceso\n");
		printf("DIA   : Muestra el display del proceso en alarma \n");
		printf("DISP  : Muestra el display de un proceso en particular\n");
		printf("HELP  : Esta pantalla \n");
		printf("IMPHIS: Imprime el archivo historico \n");
		printf("REF   : Refresca la pantalla de display \n");
		printf("SAL   : Sale del sistema \n");
		printf("SH    : Ejecuta un shell; permite ingresar comandos\n");
		printf("\n\n\n\n\n\n");

	 	break;

	case CAMREF: /* Tasa de refresco */
#ifndef RT
		printf("Ingrese la tasa de refresco (segundos): ");
#endif
#ifdef RT
		printf("Ingrese la tasa de refresco (ticks): ");
#endif
		get_task_q(DISPLAY, &tpo_esp, &tpo_per, &pid);
		scanf("%d", &tpo_per);
#ifndef RT
		put_task_q(DISPLAY, tpo_esp, tpo_per, pid);
#endif
#ifdef RT
		read(pp_tasa[0],tpo_per_s,3);
		write(pp_tasa[1],itoa(tpo_per),3);
#endif
		break;

	case REF:   /* Refresca pantalla  display */
		get_task_q(DISPLAY, &tpo_esp, &tpo_per, &pid);
		kill(pid, PETATE);
		break;
		
	case CLS:  /* Borra pantalla */
		clscr(); 
		break;
		
	case SAL: /* Sale del sistema */
		exit(0);
		break;
		
	case APAGAR: /* Apaga el display actual */
		read(pp_to_display[0], nom_proc, TAM_NOM);
#ifdef RT
		write(pp_to_display[1], Off, TAM_NOM);
#endif
		break;

 	case IMPHIS:  /* Imprime archivo de log */
		historic = fopen("historic.dat", "r");
		stdprn = open("/dev/lp", O_WRONLY);
		
		sprintf(buff_imp, "%s", "Listado Historico \n");
		write(stdprn, buff_imp, strlen(buff_imp));
		
		while (fscanf(historic,"%10ld%5d%5d%10ld%5d", hora, tabla,
				indice, &valor, &estado) != 0)
			{
			int i;

			sprintf(buff_imp, "%s", ctime(hora));
			for (i=0; buff_imp[i] != '\n'; i++);
			buff_imp[i] = '\0';
			write(stdprn, buff_imp, strlen(buff_imp));
			sprintf(buff_imp, "  %10s  %5d %5d %c", 
				decodificar(estado), tabla, indice, '\0');
			write(stdprn, buff_imp, strlen(buff_imp));
			print_real(STDPRN, valor);
			write(stdprn, "\n", strlen("\n"));
			}
		break;

	case DEFALM:  /* Agrego una nueva alarma */

		printf("Identificador de alarma: "); scanf("%s", almid);

		ingresar_alarmas(&tabla, &indice, nom_proc, &frec, &prio,
		  procedim, &cuando, &al_min, &al_max);

		add_alm(almid, tabla, indice, nom_proc, frec, prio, procedim,
		   cuando, al_min, al_max, (time_t) 0L);

		break;

	case DIA:
		arch_nom = fopen("/tmp/nombre", "r");
		fscanf(arch_nom, "%10s", nom_proc);	
#ifdef RT
		read(pp_to_display[0], nada, TAM_NOM);			
#endif
		write(pp_to_display[1], nom_proc, TAM_NOM);
		fclose(arch_nom);
		break;

	case ACK:
		printf("Ingrese identificador alarma: "); scanf("%s", almid);
		ack_alm(almid);
		printf("Salio de reconocer alarma \n");
		break;

        default:  
		printf("Comando erroneo \n");
		break;
	}
     }
}

mayusc(comando)
char *comando;
{
  while(*comando != '\0')
      {
      *comando = toupper(*comando);
      comando++;
      }
}

traducir(comando)
char *comando;
{
   extern char *codigos[];
   int i;

   for (i=0; strcmp(codigos[i], comando); i++);
   return(i);
}


ingreso_nombre(nom_proc)
char nom_proc[];
{
   int nro_proceso;

	printf("Ingrese nombre del proceso: ");
	scanf("%s", nom_proc);

	nro_proceso = existe_el_proceso(nom_proc); 
	return(nro_proceso);
}


init_PLC(port, tabla, indice)
int port, tabla, indice;
{
   extern add_port_q(), guardian();

   /* Esta rutina es llamada por las tareas que quieren comenzar a usar un PLC
   para engancharlo en la cola de ports ocupados */

   if (!guardian(port))
	add_port_q(port, tabla, indice);
}


str_to_tabla(tipo)
char *tipo;
{
  if (strcmp(tipo, "ENT") == 0 || strcmp(tipo, "ent") == 0)
	      return (ENT);
  if (strcmp(tipo, "DIG") == 0 || strcmp(tipo, "dig") == 0)
	      return (DIG);
  if (strcmp(tipo, "REAL") == 0 || strcmp(tipo, "real") == 0)
	      return (REAL);

  return(REAL); /* Si hay error, toma real */
}


ingresar_alarmas(tabla, indice, nom_proc, frec, prio, procedim, cuando,  
   al_min, al_max)
int *tabla, *indice, *frec, *prio, *cuando;
char nom_proc[], procedim[];
real *al_min, *al_max;
{

   extern real read_real();
   char nom_disp[TAM_NOM];
   int porc;

	printf("Proceso: "); scanf("%s", nom_proc);
	printf("Dispositivo: "); scanf("%s", nom_disp);
	getchar();
	printf("Prioridad (Evento - Atencion - Precaucion - Urgente): "); 
	*prio = getchar();
	printf("Frecuencia de muestreo (segundos): "); scanf("%d", frec);
	printf("Procedimiento asociado (default): "); scanf("%s", procedim);
	printf("Logica de accion a tomar (1-Alta; 2-Baja; 4-Tasa; 8-Digital): "); 
	scanf("%d", cuando);

	*al_min = 0L;
	printf("al_min %ld, al_max %ld\n", *al_min, *al_max);

	if (*cuando & BAJA)
	  {
	  printf("Ingrese limite inferior de alarmas \n");
	  if ((*al_min = read_real(*tabla)) == LONG_MAX) *al_min = 0L;
	  }

	*al_max = 0L;
	printf("al_min %ld, al_max %ld\n", *al_min, *al_max);
	
	if (*cuando & ALTA)
	  {
	  printf("Ingrese limite superior para alarmas \n");
	  if ((*al_max = read_real(*tabla)) == LONG_MAX) *al_max = LONG_MAX;
	  }

	printf("al_min %ld, al_max %ld\n", *al_min, *al_max);

	get_info_proc(nom_proc, nom_disp, tabla, indice, porc);
}  

